// YCbCr to RGB
sampler src;

float4 PS(float2 uv: TEXCOORD0) : COLOR0 {
	float4 px;

	// Note that we are using full-range equations here, not the standard encoding
	// with headroom.
	//	
	//	R = Y + 1.402(Cr-128)						[-179,433]
	//	G = Y - 0.34414(Cb-128) - 0.71414(Cr-128)	[-134,390]
	//	B = Y + 1.772(Cb-128)						[-227,480]

	px = tex2D(src, uv);

	float3 c = px - 128.0 / 255.0;
	float3 rgb;
	rgb.rb = px.y + c.rb*float2(1.402, 1.772);
	rgb.g = px.y - dot(c.rb, float2(0.34414, 0.71414));

	return float4(rgb, px.a);
}

technique {
	pass {
		PixelShader = compile ps_3_0 PS();
	}
}
