//	VDShader - Custom shader video filter for VirtualDub
//	Copyright (C) 2007 Avery Lee
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef f_DISASM_H
#define f_DISASM_H

#ifdef _MSC_VER
	#pragma once
#endif

class VDDisassemblyContext {
public:
	VDDisassemblyContext();
	~VDDisassemblyContext();

	bool Init(const void *data);
	const char *Disassemble(const unsigned char *source, int bytes, int& count);

public:
	static void *Decompress(void *_dst, const unsigned char *src, int /*src_len*/);
	char *ApplyRuleset(const unsigned char *rs, ptrdiff_t *sp, char *hp, const unsigned char *source, int bytes, const unsigned char *&source_end);
	char *MatchRule(const unsigned char *source, const unsigned char *pattern, int pattern_len, int bytes, ptrdiff_t *sp, char *hp, const unsigned char *&source_end);
	void ExpandRule(char *s, const unsigned char *result, const ptrdiff_t *sp_base, const unsigned char *source);

	const unsigned char *pRuleBase;
	const unsigned *pRuleSystemOffsets;
	long (*mpSymLookup)(VDDisassemblyContext *pctx, unsigned long virtAddr, char *buf, int buf_len);

	bool	mbSizeOverride;			// 66
	bool	mbAddressOverride;		// 67
	bool	mbRepnePrefix;			// F2
	bool	mbRepePrefix;			// F3
	unsigned char	rex;
	const char *pszSegmentOverride;

	ptrdiff_t	physToVirtOffset;

	void	*mpAllocBlock;
	char	*mpHeap;
	ptrdiff_t		*stack;
};

#endif
